
public class ProductEntity
{
	// Private fields, to hold the state of the Product entity
	private int productID;
	private string productName;
	private string quantityPerUnit;
	private decimal unitPrice;
	private short unitsInStock;
	private short unitsOnOrder;
	private short reorderLevel;

	// Public properties, to expose the state of the entity
	public int ProductID
	{
		get { return productID; }
		set { productID = value; }
	}

	public string ProductName
	{
		get { return productName; }
		set { productName = value; }
	}
	
	public string QuantityPerUnit
	{
		get { return quantityPerUnit; }
		set { quantityPerUnit = value; }
	}
	
	public decimal UnitPrice
	{
		get { return unitPrice; }
		set { unitPrice = value; }
	}
	
	public short UnitsInStock
	{
		get { return unitsInStock; }
		set { unitsInStock = value; }
	}
	
	public short UnitsOnOrder
	{
		get { return unitsOnOrder; }
		set { unitsOnOrder = value; }
	}
	
	public short ReorderLevel
	{
		get { return reorderLevel; }
		set { reorderLevel = value; }
	}
	
	// Methods and properties to perform localized processing
	public void IncreaseUnitPriceBy(decimal amount)
	{
		unitPrice += amount;
	}

	public short UnitsAboveReorderLevel
	{
		get { return (short)(unitsInStock - reorderLevel); }
	}
	
	public string StockStatus
	{
		get
		{
			return "In stock: " + unitsInStock + ", on order: " + unitsOnOrder;
		}
	}
}

